<?php
namespace FiloBlu\Flow\Model\Filters;

class ConcatCategories extends AbstractFilter {

    public function filter($value,$args){

        $row_to_concat = $args['rows'];
        $separator = $args['separator'];

        if (!is_array($row_to_concat) || empty($row_to_concat))
            return $value;

        $row = $this->getRow();
        $_multiple_categories = array();

        foreach($row_to_concat as $rowc):

            if (isset($row[(int)$rowc]) && $row[(int)$rowc] != ''):
                if(strpos($row[(int)$rowc], '|') === false):
                    $row_mapped[] = $row[(int)$rowc];
                else:
                    $_multiple_categories = explode('|', $row[(int)$rowc]);
                endif;
            endif;
                
        endforeach;
        
        if(count($_multiple_categories)):
            // le categorie multiple (es.: Sandals|Heels) devono trovarsi all'ultimo livello che viene importato
            $part_value = implode($separator,$row_mapped);
            $list_categories = array();
            foreach($_multiple_categories as $_cat):
                $list_categories[] = $part_value . $separator . trim($_cat);
            endforeach;
            
            $value = implode('|',$list_categories);
            return $value;
            
        endif;
       

        if (!count($row_mapped))
            return $value;

        $value = implode($separator,$row_mapped);

        return $value;
    }

}

